
#include <cstdlib>  /* std::rand */
#include <iostream> /* std::cout, std::endl */

#include "point.h"


/* Default constructor with random initialization */
PPoint::PPoint():
    PPoint(std::rand()%10 - 5,
           std::rand()%10 - 5) {
    /* Here we use constructor delegation */
}


PPoint::PPoint(int x, int y):
    m_x(nullptr), m_y(nullptr) {
    
    m_x = new int;
    m_y = new int;

    *m_x = x;
    *m_y = y;
    
    std::cout << "PPoint(int x, int y)" << std::endl;
}


PPoint::PPoint(const PPoint& point):
    PPoint(*(point.m_x), *(point.m_y)) {
    std::cout << "PPoint(const PPoint&)" << std::endl;
}


PPoint::~PPoint() {
    std::cout << "~PPoint()" << std::endl;
    delete m_x;
    delete m_y;
}


void PPoint::add(const PPoint& pt) {
    *m_x += *(pt.m_x);
    *m_y += *(pt.m_y);
}


void PPoint::print() const {
    std::cout << '(' << *m_x << ", " << *m_y << ')';
}
