
#ifndef PIECEWISE_H
#define PIECEWISE_H

#include "polynomial.h"

class PiecewisePoly1 {
    /* defines a piecewise polynomial function that interpolates 'npoints'   *
     * given points using first order polynomials                            */
    public:
        PiecewisePoly1(const float* Xi,  /* sorted 1d array of x coordinates */ 
                       const float* Yi,  /* values at point Xi:   Yi = F(Xi) */
                       unsigned int npoints);
        ~PiecewisePoly1();

        float xmin() const;
        float xmax() const;

        float val(float x) const;
        void dump(std::ostream& os, unsigned int N=100) const;
    private:
        unsigned int m_npoints;
        float *m_Xi, *m_Yi;
        Poly1 *m_polys;
};

#endif /* end of include guard: PIECEWISE_H */
