#ifndef POLYNOMIAL_H
#define POLYNOMIAL_H

#include <ostream>   /* std::ostream */
#include <cmath>     /* defines NAN */
                      
class Poly0 {
    /* P(x) = a0 */
    public:
        Poly0(float a0=NAN);
        Poly0 derivative();
        float val(float x);
        
        void print_polynomial(std::ostream &os);
    private:
        float m_a0;
};


class Poly1 {
    /* P(x) = a0 + a1*x */
    public:
        Poly1(float a0=NAN, float a1=NAN);
        Poly0 derivative();
        float val(float x);
        float zero(float a, float b);
        void print_polynomial(std::ostream &os);
    private:
        float m_a0, m_a1;
};

#endif /* end of include guard: POLYNOMIAL_H */
