
#include <cstdlib>   /* std::atoi, EXIT_FAILURE, EXIT_SUCCESS */
#include <cassert>   /* assert */
#include <iostream>  /* std::cout */

#include "piecewise.h"  /* PiecewisePoly1 class definition */

int main(int argc, const char *argv[]) {
    
    if (argc != 2) {
        std::cerr << "Usage " << argv[0]  << " [N]" << std::endl;
        return EXIT_FAILURE;
    }
    const int N = std::atoi(argv[1]);
    assert(N>0);
        
    /* Create a list of points and a piecewise polynomial */
    const int npoints = 6;
    float Xi[npoints] = { 0.0f, 0.50f, 1.0f, 2.0f, 2.5f, 3.0f  };
    float Yi[npoints] = { 0.0f, -1.0f, 0.50f, 1.5f, 2.0f, 1.0f };
    PiecewisePoly1 ppoly(Xi, Yi, npoints);

    ppoly.dump(std::cout, (unsigned int)(N));

    return EXIT_SUCCESS;
}
